net install reghdfe
ssc install ivreghdfe
ssc install bacondecomp

//运行后续代码前重新运行该代码
use "C:\Users\Administrator\Desktop\2024-0038\data.dta",clear
xtset code year
gen lnedu = log(edu)
gen lnroad = log(road)
gen lnmobile = log(mob)
gen lngrp = log(grp)
gen colpatent = num_samecluster/pop

//表1 基准回归分析__(1)-(2)列
reghdfe colpatent treatment, absorb(code year) vce(cl code)
est sto base1
reghdfe colpatent treatment policy1 policy2 lngrp lnmob lnroad lnedu gov str urb , absorb(code year) vce(cl code)
est sto base2
outreg2 [base1 base2] using base.doc ,replace adjr2 dec(3)

//表1 基准回归分析__(3)-(4)列
gen iv =riverdensity*dialect*log(allpatent)
reghdfe treatment iv policy1 policy2 lngrp lnmob lnroad lnedu gov str urb , absorb(code year) vce(cl code)
ivreghdfe colpatent (treatment=iv) policy1 policy2 lngrp lnmob lnroad lnedu gov str urb, absorb(code year) cl(code) first endog(treatment)

//表2 机制检验-人员交流
gen extensive=hezuogeshu/pop
gen intensive = num_samecluster/ hezuogeshu
replace intensive =0 if intensive == .
reghdfe extensive treatment policy1 policy2 lngrp lnmob lnroad lnedu gov str urb , absorb(code year) vce(cl code)
est sto extensive
reghdfe intensive treatment policy1 policy2 lngrp lnmob lnroad lnedu gov str urb , absorb(code year) vce(cl code)
est sto intensive

gen extensivenew = xinhezuozuhe2nian/pop
gen extensiveresist = chixuhezuozuhe2nian /pop
gen intensivenonew = (num_samecluster- xinhezuoshuliang2nian ) / (hezuogeshu- xinhezuozuhe2nian)
drop if year ==2011
drop if year ==2012
replace intensivenonew =0 if intensivenonew == .
reghdfe extensivenew treatment policy1 policy2 lngrp lnmob lnroad lnedu gov str urb , absorb(code year) vce(cl code)
est sto extensivenew
reghdfe extensiveresist treatment policy1 policy2 lngrp lnmob lnroad lnedu gov str urb , absorb(code year) vce(cl code)
est sto extensiveresist
reghdfe intensivenonew treatment policy1 policy2 lngrp lnmob lnroad lnedu gov str urb , absorb(code year) vce(cl code)
est sto intensivenonew

outreg2 [extensive intensive extensivenew extensiveresist intensivenonew ] using mec1.doc ,replace adjr2 dec(3)


//表3 机制检验-跨机构融合
gen colpatent_s = patent_same/pop
gen colpatent_d = patent_diff/pop
gen ratio = colpatent_s/colpatent_d
gen ent_uni = patentAB/pop
gen ent_ins = patentAC/pop
gen uni_ins = patentBC/pop

reghdfe colpatent_s treatment policy1 policy2 lngrp lnmob lnroad lnedu gov str urb , absorb(code year) vce(cl code)
est sto colpatent_s
reghdfe colpatent_d treatment policy1 policy2 lngrp lnmob lnroad lnedu gov str urb , absorb(code year) vce(cl code)
est sto colpatent_d
reghdfe ratio treatment policy1 policy2 lngrp lnmob lnroad lnedu gov str urb , absorb(code year) vce(cl code)
est sto ratio
reghdfe ent_uni treatment policy1 policy2 lngrp lnmob lnroad lnedu gov str urb , absorb(code year) vce(cl code)
est sto ent_uni
reghdfe ent_ins treatment policy1 policy2 lngrp lnmob lnroad lnedu gov str urb , absorb(code year) vce(cl code)
est sto ent_ins
reghdfe uni_ins treatment policy1 policy2 lngrp lnmob lnroad lnedu gov str urb , absorb(code year) vce(cl code)
est sto uni_ins

outreg2 [ colpatent_s colpatent_d ratio ent_uni ent_ins uni_ins ] using mec2.doc ,replace adjr2 dec(3)

//表4 机制检验-跨学科融合
reghdfe patent_knowledge1 treatment policy1 policy2 lngrp lnmob lnroad lnedu gov str urb , absorb(code year) vce(cl code)
est sto patent_knowledge1
reghdfe patent_knowledge2 treatment policy1 policy2 lngrp lnmob lnroad lnedu gov str urb , absorb(code year) vce(cl code)
est sto patent_knowledge2
reghdfe patent_knowledge3 treatment policy1 policy2 lngrp lnmob lnroad lnedu gov str urb , absorb(code year) vce(cl code)
est sto patent_knowledge3

outreg2 [ patent_knowledge1 patent_knowledge2 patent_knowledge3 ] using mec3.doc ,replace adjr2 dec(3)

//表5 集聚与扩散机制检验-高技能人才
gen lnhightech = log(pops1+pops2)
gen lns1 = log(pops1)
gen lns2 = log(pops2)
reghdfe lnhightech treatment policy1 policy2 lngrp lnmob lnroad lnedu gov str urb , absorb(code year) vce(cl code)
est sto lnhightech
reghdfe lns1 treatment policy1 policy2 lngrp lnmob lnroad lnedu gov str urb , absorb(code year) vce(cl code)
est sto lns1
reghdfe lns2 treatment policy1 policy2 lngrp lnmob lnroad lnedu gov str urb , absorb(code year) vce(cl code)
est sto lns2
outreg2 [ lnhightech lns1 lns2 ] using mec4(1).doc ,replace adjr2 dec(3)


gen E1 = ((pops1+pops2)/(pops1+pops2+pops3))/((pops1/bilis1+pops2/bilis2)/(pops1/bilis1+pops2/bilis2+pops3/bilis3))
gen E2 = (pops1/(pops1+pops2+pops3))/((pops1/bilis1)/(pops1/bilis1+pops2/bilis2+pops3/bilis3))
gen E3 = (pops2/(pops1+pops2+pops3))/((pops2/bilis2)/(pops1/bilis1+pops2/bilis2+pops3/bilis3))
drop if hexin == 1
reghdfe E1 treatment policy1 policy2 lngrp lnmob lnroad lnedu gov str urb , absorb(code year) vce(cl code)
est sto E1
reghdfe E2 treatment policy1 policy2 lngrp lnmob lnroad lnedu gov str urb , absorb(code year) vce(cl code)
est sto E2
reghdfe E3 treatment policy1 policy2 lngrp lnmob lnroad lnedu gov str urb , absorb(code year) vce(cl code)
est sto E3
outreg2 [ E1 E2 E3 ] using mec4(2).doc ,replace adjr2 dec(3)


//表6 集聚与扩散机制检验-高新技术产业
gen lntechent1 = log(techent1+1)
gen lntechent2 = log(techent2+1)
reghdfe lntechent1 treatment policy1 policy2 lngrp lnmob lnroad lnedu gov str urb , absorb(code year) vce(cl code)
est sto lntechent1
reghdfe lntechent2 treatment policy1 policy2 lngrp lnmob lnroad lnedu gov str urb , absorb(code year) vce(cl code)
est sto lntechent2
outreg2 [ lntechent1 lntechent2 ] using mec5(1).doc ,replace adjr2 dec(3)

drop if hexin == 1
reghdfe F1 treatment policy1 policy2 lngrp lnmob lnroad lnedu gov str urb , absorb(code year) vce(cl code)
est sto F1
reghdfe F2 treatment policy1 policy2 lngrp lnmob lnroad lnedu gov str urb , absorb(code year) vce(cl code)
est sto F2
outreg2 [ F1 F2 ] using mec5(2).doc ,replace adjr2 dec(3)


//表7 集聚与扩散机制检验-创新投入与产出
gen lnexp = log(exp+1)
gen lninv = log(inv+1)
gen lntra = log(tra+1)
gen lncon = log(con+1)
reghdfe lnexp treatment policy1 policy2 lngrp lnmob lnroad lnedu gov str urb , absorb(code year) vce(cl code)
est sto lnexp
reghdfe lninv treatment policy1 policy2 lngrp lnmob lnroad lnedu gov str urb , absorb(code year) vce(cl code)
est sto lninv
reghdfe lntra treatment policy1 policy2 lngrp lnmob lnroad lnedu gov str urb , absorb(code year) vce(cl code)
est sto lntra
reghdfe lncon treatment policy1 policy2 lngrp lnmob lnroad lnedu gov str urb , absorb(code year) vce(cl code)
est sto lncon
outreg2 [ lnexp lninv lntra lncon ] using mec6(1).doc ,replace adjr2 dec(3)

drop if hexin == 1
reghdfe Gexp treatment policy1 policy2 lngrp lnmob lnroad lnedu gov str urb , absorb(code year) vce(cl code)
est sto Gexp
reghdfe Ginv treatment policy1 policy2 lngrp lnmob lnroad lnedu gov str urb , absorb(code year) vce(cl code)
est sto Ginv
reghdfe Gtra treatment policy1 policy2 lngrp lnmob lnroad lnedu gov str urb , absorb(code year) vce(cl code)
est sto Gtra
outreg2 [ Gexp Ginv Gtra ] using mec6(2).doc ,replace adjr2 dec(3)


//图II1 平行趋势检验
gen event = year-treat_date+1 if treat_i==1
replace event = -4 if event <= -4 
replace event = 4 if event >= 4    // 缩尾处理
tab event , gen(eventz)
replace eventz1 = 0 if eventz1 == .
replace eventz2 = 0 if eventz2 == .
replace eventz3 = 0 if eventz3 == .
replace eventz4 = 0 if eventz4 == .
replace eventz5 = 0 if eventz5 == .
replace eventz6 = 0 if eventz6 == .
replace eventz7 = 0 if eventz7 == .
replace eventz8 = 0 if eventz8 == .
replace eventz9 = 0 if eventz9 == .
rename eventz1 d_4
rename eventz2 d_3
rename eventz3 d_2
rename eventz4 d_1
rename eventz5 d0
rename eventz6 d1
rename eventz7 d2
rename eventz8 d3
rename eventz9 d4
drop d_1                    //将d_1作为基准期
reghdfe colpatent d_4-d_2 d0-d4 policy1 policy2 lngrp lnmob lnroad lnedu gov str urb , absorb(code year) vce(cl code)
coefplot, keep(d*)  coeflabels(d_4="-4" d_3="-3" d_2="-2"   d0="0"   d1="1"  d2="2"  d3="3"  d4="4" d5="5" )    ///
vertical  addplot(line @b @at) ytitle("合作创新水平") xtitle("年份") yline(0) levels(90) scheme(s1mono) ciopts(recast(rcap) lpattern(dash))

//图II2 安慰剂检验
clear
forvalue i=1/1000{
 use "C:\Users\Administrator\Desktop\2024-0038\data.dta",clear
 gen lnedu = log(edu)
 gen lnroad = log(road)
 gen lnmobile = log(mob)
 gen lngrp = log(grp)
 gen colpatent = num_samecluster/pop
 rename treatment did
 g obs_id= _n 
 gen random_digit= runiform() 
 sort random_digit 
 g random_id= _n 
 preserve
 keep random_id did 
 rename did random_did
 rename random_id id 
 label var id 
 save random_did, replace
 restore 
 drop random_digit random_id did 
 rename obs_id id
  label var id 
 save rawdata, replace 
 use rawdata, clear
 merge 1:1 id using random_did,nogen
 reghdfe colpatent random_did policy1 policy2 lngrp lnmob lnroad lnedu gov str urb , absorb(code year) vce(cl code)
 g _b_random_did= _b[random_did] 
 g _se_random_did= _se[random_did] 
 keep _b_random_did _se_random_did 
 duplicates drop _b_random_did, force
 save placebo`i', replace 
}
 use placebo1, clear
forvalue i=2/1000{
 append using placebo`i' 
} 
gen tvalue= _b_random_did/ _se_random_did
sum tvalue
kdensity tvalue,normal scheme(s1mono) xtitle("t 值") ytitle("分布")

//表II1 Goodman-Bacon分解
use "C:\Users\Administrator\Desktop\2024-0038\data.dta",clear
xtset code year
gen lnedu = log(edu)
gen lnroad = log(road)
gen lnmobile = log(mob)
gen lngrp = log(grp)
gen colpatent = num_samecluster/pop

bacondecomp colpatent treatment, ddetail       // Goodman-Bacon分解

//表II2 被解释变量再考量
gen colpatent_inv = inventpatent/pop
gen iv =riverdensity*dialect*log(allpatent)
reghdfe colpatent_inv treatment policy1 policy2 lngrp lnmob lnroad lnedu gov str urb , absorb(code year) vce(cl code)
ivreghdfe colpatent_inv (treatment=iv) policy1 policy2 lngrp lnmob lnroad lnedu gov str urb, absorb(code year) cl(code) first endog(treatment)

//表A1 创新关注度与合作创新回归结果
gen innovation_treat= treatment* innovation
gen innovation_treat1= treatment* innovation1
gen innovation_treat2= treatment* innovation2
gen innovation_treat3= treatment* innovation3
gen innovation_treatk= treatment* innovation_k
gen innovation_treatk1= treatment* innovation_k1
gen innovation_treatk2= treatment* innovation_k2
gen innovation_treatk3= treatment* innovation_k3

drop if cluster == 1
reghdfe colpatent innovation_treat policy1 policy2 lngrp lnmob lnroad lnedu gov str urb , absorb(code year) vce(cl code)
est sto innovation_treat
reghdfe colpatent innovation_treat1 innovation_treat2 innovation_treat3 policy1 policy2 lngrp lnmob lnroad lnedu gov str urb , absorb(code year) vce(cl code)
est sto innovation_treat123
reghdfe colpatent innovation_treatk policy1 policy2 lngrp lnmob lnroad lnedu gov str urb , absorb(code year) vce(cl code)
est sto innovation_treatk
reghdfe colpatent innovation_treatk1 innovation_treatk2 innovation_treatk3 policy1 policy2 lngrp lnmob lnroad lnedu gov str urb , absorb(code year) vce(cl code)
est sto innovation_treatk123

outreg2 [ innovation_treat innovation_treat123 innovation_treatk innovation_treatk123 ] using last2.doc ,replace adjr2 dec(3)

//表A2 合作创新的替代效应检验
gen colpatent_diff = co_diff/pop
gen colpatent_samediff = co_samediff/pop
gen colpatent_self = co_self/pop
gen selfpatent = self/pop
gen patent_all = all/pop

reghdfe colpatent_diff treatment policy1 policy2 lngrp lnmob lnroad lnedu gov str urb , absorb(code year) vce(cl code)
est sto colpatent_diff
reghdfe colpatent_samediff treatment policy1 policy2 lngrp lnmob lnroad lnedu gov str urb , absorb(code year) vce(cl code)
est sto colpatent_samediff
reghdfe colpatent_self treatment policy1 policy2 lngrp lnmob lnroad lnedu gov str urb , absorb(code year) vce(cl code)
est sto colpatent_self
reghdfe selfpatent treatment policy1 policy2 lngrp lnmob lnroad lnedu gov str urb , absorb(code year) vce(cl code)
est sto selfpatent
reghdfe patent_all treatment policy1 policy2 lngrp lnmob lnroad lnedu gov str urb , absorb(code year) vce(cl code)
est sto patent_all
outreg2 [ colpatent_diff colpatent_samediff colpatent_self selfpatent patent_all ] using last3.doc ,replace adjr2 dec(3)


//表III2 合作创新的溢出效应
gen event = year-treat_date+1 if treat_i==1
tab event , gen(eventz)
replace eventz1 = 0 if eventz1 == .
replace eventz2 = 0 if eventz2 == .
replace eventz3 = 0 if eventz3 == .
replace eventz4 = 0 if eventz4 == .
replace eventz5 = 0 if eventz5 == .
replace eventz6 = 0 if eventz6 == .
replace eventz7 = 0 if eventz7 == .
replace eventz8 = 0 if eventz8 == .
replace eventz9 = 0 if eventz9 == .
replace eventz10 = 0 if eventz10 == .
replace eventz11 = 0 if eventz11 == .
replace eventz12 = 0 if eventz12 == .
replace eventz13 = 0 if eventz13 == .
rename eventz1 d_6
rename eventz2 d_5
rename eventz3 d_4
rename eventz4 d_3
rename eventz5 d_2
rename eventz6 d_1
rename eventz7 d0
rename eventz8 d1
rename eventz9 d2
rename eventz10 d3
rename eventz11 d4
rename eventz12 d5
rename eventz13 d6
drop d_1                    //将d_1作为基准期
reghdfe colpatent_diff d_6-d_2 d0-d6 policy1 policy2 lngrp lnmob lnroad lnedu gov str urb , absorb(code year) vce(cl code)
est sto colpatent_diff
reghdfe colpatent_samediff d_6-d_2 d0-d6 policy1 policy2 lngrp lnmob lnroad lnedu gov str urb , absorb(code year) vce(cl code)
est sto colpatent_samediff
reghdfe colpatent_self d_6-d_2 d0-d6 policy1 policy2 lngrp lnmob lnroad lnedu gov str urb , absorb(code year) vce(cl code)
est sto colpatent_self
reghdfe selfpatent d_6-d_2 d0-d6 policy1 policy2 lngrp lnmob lnroad lnedu gov str urb , absorb(code year) vce(cl code)
est sto selfpatent
reghdfe patent_all d_6-d_2 d0-d6 policy1 policy2 lngrp lnmob lnroad lnedu gov str urb , absorb(code year) vce(cl code)
est sto patent_all
outreg2 [ colpatent_diff colpatent_samediff colpatent_self selfpatent patent_all ] using last4.doc ,replace adjr2 dec(3)

//表III3 异质性分析回归结果
gen inter1= treatment* multicenter1
gen inter2= treatment* multicenter2
gen inter3= treatment* starent
gen inter4= treatment* university
reghdfe colpatent treatment inter1 policy1 policy2 lngrp lnmob lnroad lnedu gov str urb , absorb(code year) vce(cl code)
est sto enter1
reghdfe colpatent treatment inter2 policy1 policy2 lngrp lnmob lnroad lnedu gov str urb , absorb(code year) vce(cl code)
est sto enter2
reghdfe colpatent treatment inter3 policy1 policy2 lngrp lnmob lnroad lnedu gov str urb , absorb(code year) vce(cl code)
est sto enter3
reghdfe colpatent treatment inter4 policy1 policy2 lngrp lnmob lnroad lnedu gov str urb , absorb(code year) vce(cl code)
est sto enter4
outreg2 [ enter1 enter2 enter3 enter4 ] using last1.doc ,replace adjr2 dec(3)